var gusertoken="";
var guserroles="";
var gusertokencheck=false;

function dologin() {
    loginemail = document.getElementById("testemail").value;
    loginpassword = document.getElementById("testpassword").value;
    apicall = "https://realspring.backendless.app/api/users/login";
    request = new XMLHttpRequest();
    request.open('POST', apicall);
    request.setRequestHeader("Content-Type", "application/json");
    request.setRequestHeader("Application-Type", "REST");
    data = { 'login': loginemail, 'password': loginpassword };
    request.onload = function () {
        if (request.readyState == 4) {
          result = JSON.parse(request.response);
          if (request.status === 200) {
              gusertoken = result['user-token'];
              document.getElementById("loginmessage").innerText = 'Login Successful. User token is '+gusertoken;
              getuserroles();
              checkusertoken();
              document.getElementById("button1amessage").innerText = "";
              document.getElementById("button1bmessage").innerText = "";
              document.getElementById("button2amessage").innerText = "";
              document.getElementById("button2bmessage").innerText = "";
            }
          else {
              console.log( "error - " + result.message );
          }
        }
    }
    request.send(JSON.stringify(data));
};

function grantcount() {
    apicall = "https://realspring.backendless.app/api/data/GrantAllToNonAuthenticatedRole/count";
    request = new XMLHttpRequest();
    request.open('GET', apicall);
    request.setRequestHeader("Content-Type", "application/json");
    if (gusertoken!="") {
        request.setRequestHeader('user-token', gusertoken);
    }
    request.onload = function() {
        document.getElementById("button2bmessage").innerText = "count is: "+ this.responseText + " for usertoken " + gusertoken;
    }   
    request.send();
}

function denycount() {
    apicall = "https://realspring.backendless.app/api/data/DenyAllToNonAuthenticatedRole/count";
    request = new XMLHttpRequest();
    request.open('GET', apicall);
    request.setRequestHeader("Content-Type", "application/json");
    if (gusertoken!="") {
        request.setRequestHeader('user-token', gusertoken);
    }
    request.onload = function() {
        document.getElementById("button1bmessage").innerText = "count is: "+ this.responseText + " for usertoken " + gusertoken;
    }   
    request.send();
}


function getuserroles()  {
    apicall = "https://realspring.backendless.app/api/users/userroles";
    request = new XMLHttpRequest();
    request.onload = function() {
        document.getElementById("userroles").innerText = "User roles are:  " + this.responseText;
    }   
    request.open('GET', apicall);
    // request.setRequestHeader("Content-Type", "application/json");
    if (gusertoken!="") {
        request.setRequestHeader('user-token', gusertoken);
    }
    request.send();
}


function checkusertoken()  {
    apicall = "https://realspring.backendless.app/api/users/isvalidusertoken/" + gusertoken;
    request = new XMLHttpRequest();
    request.open('GET', apicall, true);
    request.setRequestHeader("Content-Type", "application/json");
    request.onload = function () {
        if (request.readyState == 4) {
          result = JSON.parse(request.response);
          if (request.status === 200) {
              gusertokencheck = result.toString();
              document.getElementById("usertokencheck").innerText = 'Token for logged user is valid ' + gusertokencheck;
          }
          else {
              gusertokencheck = false;
              document.getElementById("usertokencheck").innerText = 'Token for user is not valid ';
          }
        }
    }
    request.send();
}


function addrecordtodeny() {
    payload = {
      testvalue: "testing123",
     };
     getuserroles();
     apicall = "https://realspring.backendless.app/api/data/DenyAllToNonAuthenticatedRole";
     fetch(apicall, {
        method: 'POST',
        'Content-Type': 'application/json',
        'user-token': gusertoken,
         body: JSON.stringify(payload),
      })
        .then((response) => response.json())
        .then(function (result) {
         if (!result.hasOwnProperty('message')) {
             document.getElementById("button1amessage").innerText = "record successfully added using usertoken " + gusertoken;
         } else {
             document.getElementById("button1amessage").innerText = result.message;
         };
      })
        .catch( function( error ) {
          console.log( "error - " + error.message );
      });  
      denycount();
  }
  
  function addrecordtogrant() {
    payload = {
      testvalue: "testing123",
     };
     getuserroles();
     apicall = "https://realspring.backendless.app/api/data/GrantAllToNonAuthenticatedRole";
     fetch(apicall, {
       method: 'POST',
       'Content-Type': 'application/json',
       'user-token': gusertoken,
        body: JSON.stringify(payload),
     })
       .then((response) => response.json())
       .then(function (result) {
        if (!result.hasOwnProperty('message')) {
            document.getElementById("button2amessage").innerText = "record successfully added using usertoken " + gusertoken;
        } else {
            document.getElementById("button2amessage").innerText = result.message;
        };
     })
       .catch( function( error ) {
         console.log( "error - " + error.message );
     });  
     grantcount();
  }

